Index: protocol/src/main/java/geniusweb/protocol/session/mopac2/MOPAC2State.java
===================================================================
--- protocol/src/main/java/geniusweb/protocol/session/mopac2/MOPAC2State.java	(revision 30)
+++ protocol/src/main/java/geniusweb/protocol/session/mopac2/MOPAC2State.java	(revision 30)
@@ -0,0 +1,358 @@
+package geniusweb.protocol.session.mopac2;
+
+import java.util.Arrays;
+import java.util.Collections;
+import java.util.HashMap;
+import java.util.LinkedList;
+import java.util.List;
+import java.util.Map;
+
+import com.fasterxml.jackson.annotation.JsonCreator;
+import com.fasterxml.jackson.annotation.JsonProperty;
+
+import geniusweb.actions.Action;
+import geniusweb.actions.PartyId;
+import geniusweb.inform.Agreements;
+import geniusweb.inform.OptIn;
+import geniusweb.progress.Progress;
+import geniusweb.progress.ProgressRounds;
+import geniusweb.protocol.NegoProtocol;
+import geniusweb.protocol.ProtocolException;
+import geniusweb.protocol.session.SessionResult;
+import geniusweb.protocol.session.SessionState;
+import geniusweb.protocol.session.mopac2.phase.OfferPhase;
+import geniusweb.protocol.session.mopac2.phase.OptInPhase;
+import geniusweb.protocol.session.mopac2.phase.Phase;
+import geniusweb.protocol.session.saop.SAOPSettings;
+import geniusweb.references.PartyWithProfile;
+
+/**
+ * Keeps track of the current {@link Phase}. Adds initializing stuff and
+ * time/deadline checking. This state does not contain connections, this assumes
+ * that someone else handles (i.e. {@link NegoProtocol} that and the connections
+ * with the parties and that negotiation events are just pumped in from there.
+ * <p>
+ * This object is a bit tricky. It has two states
+ * <ol>
+ * <li>The initial state, where phase=null and connections are being made to all
+ * parties. At this point, problems can not be handled nicely yet because there
+ * are no PartyId's for problematic parties
+ * <li>The working state, where all parties are connected and all problems can
+ * be connected to an offending party.
+ * </ol>
+ */
+public class MOPAC2State implements SessionState {
+
+	private final Phase phase; // maybe null while initializing
+	private final MOPAC2Settings settings;
+	private final Map<PartyId, PartyWithProfile> partyprofiles;
+	private final List<Action> actions;
+	private final Progress progress;
+
+	/**
+	 * Creates the initial state from the given settings and progress=null
+	 * 
+	 * @param settings the {@link SAOPSettings}
+	 */
+	public MOPAC2State(MOPAC2Settings settings) {
+		this(null, Arrays.asList(), null, settings, Collections.emptyMap());
+
+	}
+
+	/**
+	 * @param phase         The Phase, or null if still initializing. Phase is
+	 *                      set something only after we have connections.
+	 * @param actions       the legal actions that have been done in the
+	 *                      negotiation. {@link PartyStates#getActions()} is
+	 *                      called to collect the actions after the phase is
+	 *                      finished.first action in list is the oldest. This
+	 *                      will not contain actions that immediately led to an
+	 *                      agreement, because {@link PartyStates} removes the
+	 *                      actions that led to an agreement. This MUST NOT
+	 *                      contain illegal actions. Parties doing illegal
+	 *                      actions are killed and the offending action ends up
+	 *                      in the stacktrace. Previous actions of crashed
+	 *                      parties remain standing and valid.
+	 * @param progress      the {@link Progress} line. can be null if not yet
+	 *                      known. null happens because during initialization
+	 *                      phase the protocol first add all connections. During
+	 *                      this time, parties may already enter the
+	 *                      failed/exception state.
+	 * @param settings      the {@link SAOPSettings}
+	 * @param partyprofiles map with the {@link PartyWithProfile} for connected
+	 *                      parties. null is equivalent to an empty map.
+	 */
+	@JsonCreator
+	protected MOPAC2State(@JsonProperty("phase") Phase phase,
+			@JsonProperty("actions") List<Action> actions,
+			@JsonProperty("progress") Progress progress,
+			@JsonProperty("settings") MOPAC2Settings settings,
+			@JsonProperty("partyprofiles") Map<PartyId, PartyWithProfile> partyprofiles) {
+		this.phase = phase;
+		this.actions = actions;
+		this.progress = progress;
+		this.settings = settings;
+		this.partyprofiles = partyprofiles;
+	}
+
+	/**
+	 * Sets the progress for this session and initial phase. Must be called
+	 * after all parties have been connected with
+	 * {@link #with(PartyId, PartyWithProfile)}.
+	 * 
+	 * @param newprogress the initial {@link Progress} typically matching the
+	 *                    settings deadline object
+	 * @param now         current time ms since 1970
+	 * 
+	 * @return state with the initial partystates , progress set.
+	 */
+	public MOPAC2State initPhase(Progress newprogress, long now) {
+		if (progress != null || newprogress == null || phase != null) {
+			throw new IllegalArgumentException(
+					"progress must be null, newprogress must be not null and phase must be INIT");
+		}
+
+		PartyStates partyStates = new PartyStates(getPowers());
+		Phase firstPhase = new OfferPhase(partyStates,
+				now + getAvailablePhaseTime(newprogress, now),
+				settings.getVotingEvaluation());
+		return new MOPAC2State(firstPhase, actions, newprogress, settings,
+				partyprofiles);
+	}
+
+	@Override
+	public List<Action> getActions() {
+		return Collections.unmodifiableList(actions);
+	}
+
+	@Override
+	public Progress getProgress() {
+		return progress;
+	}
+
+	@Override
+	public Agreements getAgreements() {
+		return phase.getPartyStates().getAgreements();
+	}
+
+	@Override
+	public MOPAC2Settings getSettings() {
+		return settings;
+	}
+
+	public Map<PartyId, PartyWithProfile> getPartyProfiles() {
+		return Collections.unmodifiableMap(partyprofiles);
+	}
+
+	@Override
+	public boolean isFinal(long now) {
+		return phase != null && phase.isFinal(now) && !isNewPhasePossible(now);
+	}
+
+	@Override
+	public SessionResult getResult() {
+		return new SessionResult(partyprofiles, getAgreements(),
+				Collections.emptyMap(), null);
+	}
+
+	/**
+	 * @param progress the Progress that needs to be checked
+	 * @param now      current time ms since 1970
+	 * @return the max possible duration in ms of a phase considering the
+	 *         progress.
+	 */
+	private static Long getAvailablePhaseTime(Progress aprogress, long now) {
+		return Math.min(aprogress.getTerminationTime().getTime() - now,
+				Phase.PHASE_MAXTIME);
+	}
+
+	/**
+	 * @param id           the new {@link PartyId}
+	 * @param partyprofile the {@link PartyWithProfile} that is associated with
+	 *                     this state
+	 * @return new {@link MOPAC2State} with the new party added. This call
+	 *         ignores the progress (does not check isFinal) because we uses
+	 *         this during the setup where the deadline is not yet relevant.
+	 */
+	protected MOPAC2State with(PartyId id, PartyWithProfile partyprofile) {
+		if (phase != null)
+			throw new IllegalStateException(
+					"Adding connections only allowed while initializing");
+
+		Map<PartyId, PartyWithProfile> newprofiles = new HashMap<>(
+				partyprofiles);
+		newprofiles.put(id, partyprofile);
+		return new MOPAC2State(null, actions, progress, settings, newprofiles);
+	}
+
+	/**
+	 * @param e the {@link ProtocolException} that occured
+	 * @return a new state with the error set. You MUST have called
+	 *         {@link #initPhase(Progress, long)} before using this
+	 */
+	public MOPAC2State with(ProtocolException e) {
+		return new MOPAC2State(phase.with(e), actions, progress, settings,
+				partyprofiles);
+	}
+
+	/**
+	 * Start the next phase. If new phase is OfferPhase, we increase progress.
+	 * Actions is reset to empty. does nothing if not
+	 * {@link #isNewPhasePossible(long)}
+	 * 
+	 * @param now current time
+	 * @return new {@link MOPAC2State} with phase initialized for next phase.
+	 */
+	public MOPAC2State nextPhase(long now) {
+		long remainingNegoTime = progress.getTerminationTime().getTime() - now;
+		Phase newphase = phase.next(now,
+				Math.min(remainingNegoTime, Phase.PHASE_MAXTIME));
+
+		return new MOPAC2State(newphase, actions, increment(progress, phase),
+				getSettings(), partyprofiles);
+	}
+
+	/**
+	 * When this is called, all parties should have acted.
+	 * 
+	 * @param now current time
+	 * @return true if there are still &gt;2 parties active and we have enough
+	 *         time for a new phase.
+	 */
+	public boolean isNewPhasePossible(long now) {
+		// System.out.println("phase=" + phase);
+		Progress newprogress = increment(progress, phase);
+		if (newprogress.isPastDeadline(now + Phase.PHASE_MINTIME))
+			return false;
+
+		return phase.getPartyStates().getNegotiatingParties().size() >= 2
+				&& getAvailablePhaseTime(newprogress,
+						now) > Phase.PHASE_MINTIME;
+	}
+
+	public Phase getPhase() {
+		return phase;
+	}
+
+	/**
+	 * Check if action is allowed. Add action to the list of actions. Notice,
+	 * this does NOT check if we need to step to the next phase, because
+	 * deciding that is also depending on time-outs.
+	 * 
+	 * @param actor  the actor that did this action. Can be used to check if
+	 *               action is valid. NOTICE caller has to make sure the current
+	 *               state is not final. MUST NOT be null.
+	 * @param action the action that was proposed by actor. MUST NOT be null.
+	 * @param now    the current time in ms since 1970, see
+	 *               {@link System#currentTimeMillis()}
+	 * @return new {@link MOPAC2State} with the action checked and registered.
+	 *         If the action is not allowed, the new state may be that the actor
+	 *         is in the exception list.
+	 */
+
+	public MOPAC2State with(PartyId actor, Action action, long now) {
+		return new MOPAC2State(phase.with(actor, action, now), actions,
+				progress, settings, partyprofiles);
+	}
+
+	/**
+	 * @param aprogress the progress that might need to be advanced
+	 * @param aphase    the phase
+	 * @return the next progress. Progress round advances if phase is
+	 *         {@link OptIn}.
+	 */
+	private static Progress increment(Progress aprogress, Phase aphase) {
+		if (aprogress instanceof ProgressRounds && aphase instanceof OptInPhase)
+			return ((ProgressRounds) aprogress).advance();
+		return aprogress;
+	}
+
+	/**
+	 * @return the power of all parties as set in their parameters, default =1.
+	 *         bad power values (non-integer, or <1) are ignored.
+	 */
+	private Map<PartyId, Integer> getPowers() {
+		Map<PartyId, Integer> map = new HashMap<>();
+		for (PartyId pid : partyprofiles.keySet()) {
+			Object power = partyprofiles.get(pid).getParty().getParameters()
+					.get("power");
+			if (power == null || !(power instanceof Integer)
+					|| ((Integer) power) < 1)
+				power = 1;
+			map.put(pid, (Integer) power);
+		}
+		return map;
+	}
+
+	@Override
+	public String toString() {
+		return "MOPAC2State[" + phase + "," + settings + "," + partyprofiles
+				+ "," + progress + "]";
+	}
+
+	/**
+	 * 
+	 * @return a wrapped-up state, with all parties doen an action or kicked,
+	 *         and agreements collected
+	 */
+	public MOPAC2State finishPhase() {
+		Phase newphase = phase.finish();
+		LinkedList<Action> newactions = new LinkedList<Action>(actions);
+		newactions.addAll(newphase.getPartyStates().getActions());
+		return new MOPAC2State(newphase, newactions, progress, settings,
+				partyprofiles);
+	}
+
+	@Override
+	public int hashCode() {
+		final int prime = 31;
+		int result = 1;
+		result = prime * result + ((actions == null) ? 0 : actions.hashCode());
+		result = prime * result
+				+ ((partyprofiles == null) ? 0 : partyprofiles.hashCode());
+		result = prime * result + ((phase == null) ? 0 : phase.hashCode());
+		result = prime * result
+				+ ((progress == null) ? 0 : progress.hashCode());
+		result = prime * result
+				+ ((settings == null) ? 0 : settings.hashCode());
+		return result;
+	}
+
+	@Override
+	public boolean equals(Object obj) {
+		if (this == obj)
+			return true;
+		if (obj == null)
+			return false;
+		if (getClass() != obj.getClass())
+			return false;
+		MOPAC2State other = (MOPAC2State) obj;
+		if (actions == null) {
+			if (other.actions != null)
+				return false;
+		} else if (!actions.equals(other.actions))
+			return false;
+		if (partyprofiles == null) {
+			if (other.partyprofiles != null)
+				return false;
+		} else if (!partyprofiles.equals(other.partyprofiles))
+			return false;
+		if (phase == null) {
+			if (other.phase != null)
+				return false;
+		} else if (!phase.equals(other.phase))
+			return false;
+		if (progress == null) {
+			if (other.progress != null)
+				return false;
+		} else if (!progress.equals(other.progress))
+			return false;
+		if (settings == null) {
+			if (other.settings != null)
+				return false;
+		} else if (!settings.equals(other.settings))
+			return false;
+		return true;
+	}
+
+}
Index: protocol/src/main/java/geniusweb/protocol/session/mopac2/PartyStates.java
===================================================================
--- protocol/src/main/java/geniusweb/protocol/session/mopac2/PartyStates.java	(revision 30)
+++ protocol/src/main/java/geniusweb/protocol/session/mopac2/PartyStates.java	(revision 30)
@@ -0,0 +1,306 @@
+package geniusweb.protocol.session.mopac2;
+
+import java.util.Collections;
+import java.util.HashMap;
+import java.util.HashSet;
+import java.util.LinkedList;
+import java.util.List;
+import java.util.Map;
+import java.util.Set;
+import java.util.stream.Collectors;
+
+import com.fasterxml.jackson.annotation.JsonAutoDetect;
+import com.fasterxml.jackson.annotation.JsonAutoDetect.Visibility;
+import com.fasterxml.jackson.annotation.JsonCreator;
+import com.fasterxml.jackson.annotation.JsonProperty;
+
+import geniusweb.actions.Action;
+import geniusweb.actions.EndNegotiation;
+import geniusweb.actions.PartyId;
+import geniusweb.inform.Agreements;
+import geniusweb.protocol.ProtocolException;
+
+/**
+ * Invariant: contains the current state of all participating parties. A party
+ * either notYetActed, did action, reached an agreement, walked away or made a
+ * {@link ProtocolException}.
+ * <p>
+ * After a phase completes, the actions are filtered/handled to collect
+ * agreements and move remaining parties back to notYetActed.
+ * 
+ */
+@JsonAutoDetect(fieldVisibility = Visibility.ANY, getterVisibility = Visibility.NONE, setterVisibility = Visibility.NONE, isGetterVisibility = Visibility.NONE)
+public class PartyStates {
+	// all parties must be in exactly one state at all times.
+	private final Set<PartyId> notYetActed;
+	private final List<Action> actions; // chrono order
+	private final Agreements agreements;
+	private final List<PartyId> walkedAway;
+	private final Map<PartyId, ProtocolException> exceptions;
+	private final Map<PartyId, Integer> powers;
+
+	@JsonCreator
+	protected PartyStates(@JsonProperty("notYetActed") Set<PartyId> notYetActed,
+			@JsonProperty("actions") List<Action> actions,
+			@JsonProperty("agreements") Agreements agreements,
+			@JsonProperty("walkedAway") List<PartyId> walkedAway,
+			@JsonProperty("exceptions") Map<PartyId, ProtocolException> exceptions,
+			@JsonProperty("powers") Map<PartyId, Integer> powers) {
+		this.notYetActed = notYetActed;
+		this.actions = actions;
+		this.agreements = agreements;
+		this.walkedAway = walkedAway;
+		this.exceptions = exceptions;
+		this.powers = powers;
+	}
+
+	/**
+	 * Initial constructor.
+	 * 
+	 * @param powers the powers of all parties.
+	 */
+	public PartyStates(Map<PartyId, Integer> powers) {
+		this.notYetActed = new HashSet<>(powers.keySet());
+		this.actions = Collections.emptyList();
+		this.agreements = new Agreements();
+		this.walkedAway = Collections.emptyList();
+		this.exceptions = Collections.emptyMap();
+		this.powers = new HashMap<>(powers);
+	}
+
+	/**
+	 * 
+	 * @param action the action done by some party. The correctness of action,
+	 *               particularly of {@link Action#getActor()}, must be correct.
+	 * @return new state with party done given action. This just accepts any
+	 *         given action and is not considering number of rounds, time or
+	 *         whether an action is allowed.
+	 * 
+	 * @throws IllegalArgumentException if party doing action already acted.
+	 *                                  This is just a safety check as legality
+	 *                                  of actions should be checked before
+	 *                                  calling this.
+	 */
+	public PartyStates with(Action action) {
+		if (!(notYetActed.contains(action.getActor())))
+			throw new IllegalArgumentException(
+					"actor already acted: " + action);
+		if (action instanceof EndNegotiation)
+			return withWalkAway(action.getActor());
+		List<Action> newActions = new LinkedList<Action>(actions);
+		newActions.add(action);
+		return new PartyStates(removeParty(action.getActor()), newActions,
+				agreements, walkedAway, exceptions, powers);
+	}
+
+	/**
+	 * 
+	 * @param newAgree a new agreements to be merged with existing agreements.
+	 *                 The parties in the agreement must have acted and thus in
+	 *                 actions.
+	 * @return new PartyStates with agreeing parties removed from actions and
+	 *         added to Agreements.
+	 */
+	public PartyStates with(Agreements newAgree) {
+		Set<PartyId> parties = newAgree.getMap().keySet();
+		List<Action> newActions = actions.stream()
+				.filter(act -> !(parties.contains(act.getActor())))
+				.collect(Collectors.toList());
+		return new PartyStates(notYetActed, newActions,
+				agreements.with(newAgree), walkedAway, exceptions, powers);
+	}
+
+	public PartyStates withWalkAway(PartyId actor) {
+		if (!(notYetActed.contains(actor)))
+			throw new IllegalArgumentException("actor already acted: " + actor);
+		LinkedList<PartyId> newWalkAway = new LinkedList<>(walkedAway);
+		newWalkAway.add(actor);
+		return new PartyStates(removeParty(actor), actions, agreements,
+				newWalkAway, exceptions, powers);
+	}
+
+	/**
+	 * Move party from active to exceptions.
+	 * 
+	 * @param e the exception that the party caused
+	 * @return new PartyStates with party that caused the exception in the
+	 *         exceptions list and removed from the active list. Nothing happens
+	 *         if party is not active.
+	 */
+	public PartyStates with(ProtocolException e) {
+		if (!notYetActed.contains(e.getParty())) {
+			// complex case. Party did valid action but now is messing around.
+			// Easiest seems to completely ignore it. CHECK.
+			return this;
+		}
+		Map<PartyId, ProtocolException> newExc = new HashMap<>(exceptions);
+		newExc.put(e.getParty(), e);
+		return new PartyStates(removeParty(e.getParty()), actions, agreements,
+				walkedAway, newExc, powers);
+	}
+
+	/**
+	 * 
+	 * @return parties that have not yet acted
+	 */
+	public Set<PartyId> getNotYetActed() {
+		return notYetActed;
+	}
+
+	/**
+	 * 
+	 * @return parties that are still in the negotiation. These are the parties
+	 *         that not yet acted plus the ones that did an action.
+	 */
+	public Set<PartyId> getNegotiatingParties() {
+		Set<PartyId> parties = actions.stream().map(act -> act.getActor())
+				.collect(Collectors.toSet());
+		parties.addAll(notYetActed);
+		return parties;
+	}
+
+	/**
+	 * @param actor
+	 * @return {@link #notYetActed} with actor removed
+	 * @throws IllegalArgumentException if party already acted (not in
+	 *                                  {@link #notYetActed}).
+	 */
+	private Set<PartyId> removeParty(PartyId party) {
+		Set<PartyId> newActiveParties = new HashSet<>(notYetActed);
+		if (!newActiveParties.remove(party))
+			throw new IllegalArgumentException(
+					"Party " + party + " is not active, can't be removed");
+		return newActiveParties;
+
+	}
+
+	public Agreements getAgreements() {
+		return agreements;
+	}
+
+	public Map<PartyId, Integer> getPowers() {
+		return Collections.unmodifiableMap(powers);
+	}
+
+	public Map<PartyId, ProtocolException> getExceptions() {
+		return Collections.unmodifiableMap(exceptions);
+	}
+
+	/**
+	 * @return new state where all {@link #notYetActed} are moved to the
+	 *         exceptions list.
+	 */
+	public PartyStates finish() {
+		PartyStates newstate = this;
+		for (PartyId party : notYetActed) {
+			newstate = newstate
+					.with(new ProtocolException("Party did not act", party));
+		}
+		return newstate;
+	}
+
+	public List<Action> getActions() {
+		return Collections.unmodifiableList(actions);
+	}
+
+	/**
+	 * 
+	 * @return all parties that walked away
+	 */
+	public List<PartyId> getWalkedAway() {
+		return walkedAway;
+	}
+
+	/**
+	 * @param <T>  the type of objects requested
+	 * @param type the type of actions to extract. Must be of type T, needed
+	 *             because of java's type erasure.
+	 * 
+	 * @return all actions of type done in this phase
+	 */
+	public <T extends Action> List<T> getActions(Class<T> type) {
+		return actions.stream().filter(act -> type.isInstance(act))
+				.map(act -> (T) act).collect(Collectors.toList());
+	}
+
+	@Override
+	public String toString() {
+		return "PartyStates[" + notYetActed + "," + actions + "," + agreements
+				+ "," + walkedAway + "," + exceptions + "]";
+	}
+
+	/**
+	 * 
+	 * @return states with all parties that are in {@link #actions} moved back
+	 *         to {@link #notYetActed}. This state is then ready for a next
+	 *         phase.
+	 * @throws IllegalStateException if {@link #notYetActed} is not empty
+	 */
+	public PartyStates flush() {
+		if (!notYetActed.isEmpty())
+			throw new IllegalStateException(
+					"Some parties did not yet act:" + notYetActed);
+		return new PartyStates(getNegotiatingParties(), Collections.emptyList(),
+				agreements, walkedAway, exceptions, powers);
+	}
+
+	@Override
+	public int hashCode() {
+		final int prime = 31;
+		int result = 1;
+		result = prime * result + ((actions == null) ? 0 : actions.hashCode());
+		result = prime * result
+				+ ((agreements == null) ? 0 : agreements.hashCode());
+		result = prime * result
+				+ ((exceptions == null) ? 0 : exceptions.hashCode());
+		result = prime * result
+				+ ((notYetActed == null) ? 0 : notYetActed.hashCode());
+		result = prime * result + ((powers == null) ? 0 : powers.hashCode());
+		result = prime * result
+				+ ((walkedAway == null) ? 0 : walkedAway.hashCode());
+		return result;
+	}
+
+	@Override
+	public boolean equals(Object obj) {
+		if (this == obj)
+			return true;
+		if (obj == null)
+			return false;
+		if (getClass() != obj.getClass())
+			return false;
+		PartyStates other = (PartyStates) obj;
+		if (actions == null) {
+			if (other.actions != null)
+				return false;
+		} else if (!actions.equals(other.actions))
+			return false;
+		if (agreements == null) {
+			if (other.agreements != null)
+				return false;
+		} else if (!agreements.equals(other.agreements))
+			return false;
+		if (exceptions == null) {
+			if (other.exceptions != null)
+				return false;
+		} else if (!exceptions.equals(other.exceptions))
+			return false;
+		if (notYetActed == null) {
+			if (other.notYetActed != null)
+				return false;
+		} else if (!notYetActed.equals(other.notYetActed))
+			return false;
+		if (powers == null) {
+			if (other.powers != null)
+				return false;
+		} else if (!powers.equals(other.powers))
+			return false;
+		if (walkedAway == null) {
+			if (other.walkedAway != null)
+				return false;
+		} else if (!walkedAway.equals(other.walkedAway))
+			return false;
+		return true;
+	}
+
+}
Index: protocol/src/main/java/geniusweb/protocol/session/mopac2/phase/DefaultPhase.java
===================================================================
--- protocol/src/main/java/geniusweb/protocol/session/mopac2/phase/DefaultPhase.java	(revision 30)
+++ protocol/src/main/java/geniusweb/protocol/session/mopac2/phase/DefaultPhase.java	(revision 30)
@@ -0,0 +1,146 @@
+package geniusweb.protocol.session.mopac2.phase;
+
+import geniusweb.actions.Action;
+import geniusweb.actions.PartyId;
+import geniusweb.protocol.ProtocolException;
+import geniusweb.protocol.session.mopac2.PartyStates;
+import geniusweb.voting.VotingEvaluator;
+import geniusweb.voting.VotingEvaluatorWithValue;
+
+public abstract class DefaultPhase implements Phase {
+	// deadline for this phase, ms since 1970
+	protected final Long deadline;
+	protected final PartyStates partyStates;
+	protected final VotingEvaluatorWithValue evaluator;
+
+	/**
+	 * @param partyStates the {@link PartyStates}
+	 * @param deadline    deadline for this phase, ms since 1970
+	 * @param evaluator   the {@link VotingEvaluator} to be used
+	 */
+	public DefaultPhase(PartyStates partyStates, Long deadline,
+			VotingEvaluatorWithValue evaluator) {
+		this.partyStates = partyStates;
+		this.deadline = deadline;
+		this.evaluator = evaluator;
+	}
+
+	@Override
+	public boolean isFinal(long now) {
+		return now >= deadline || partyStates.getNotYetActed().isEmpty();
+	}
+
+	@Override
+	public long getDeadline() {
+		return deadline;
+	}
+
+	/**
+	 * Check if actor can do given action. Basic checks:
+	 * <ul>
+	 * <li>real actor does not match action's actor
+	 * <li>deadline for this phase has passed
+	 * <li>action is not allowed in this phase
+	 * <li>actor already acted in this phase
+	 * </ul>
+	 * 
+	 * @param actor  the actor that really acted
+	 * @param action the action that was done
+	 * @param now    current time
+	 * @throws ProtocolException if the action violates the protocol
+	 */
+	protected void checkAction(PartyId actor, Action action, long now)
+			throws ProtocolException {
+		if (action == null)
+			throw new ProtocolException("Action=null", actor);
+		if (!(actor.equals(action.getActor())))
+			throw new ProtocolException(
+					"Incorrect actor info in action:" + action.getActor(),
+					actor);
+		if (isFinal(now))
+			throw new ProtocolException("passed deadline", actor);
+		if (!(getAllowedActions().contains(action.getClass())))
+			throw new ProtocolException("Action not allowed in "
+					+ this.getClass().getSimpleName() + ": " + action, actor);
+		if (!partyStates.getNotYetActed().contains(actor))
+			throw new ProtocolException("Actor can not act anymore", actor);
+		return;
+	}
+
+	/**
+	 * @return current PartyStates
+	 */
+	@Override
+	public PartyStates getPartyStates() {
+		return partyStates;
+	}
+
+	@Override
+	public VotingEvaluatorWithValue getEvaluator() {
+		return evaluator;
+	}
+
+	@Override
+	public Phase next(long now, long duration) {
+		if (duration < PHASE_MINTIME || duration > PHASE_MAXTIME)
+			throw new IllegalArgumentException("Bug, illegal duration");
+		if (!isFinal(now))
+			throw new IllegalStateException("phase is not final");
+		return checkedNext(now + duration);
+	}
+
+	/**
+	 * As {@link #next(long, long)} but DefaultPhase already checked that 1.
+	 * there is enough time for a next phase 2. current state is final 3.
+	 * 
+	 * @param dl the deadline for the next phase (ms since 1970).
+	 * @return the next phase
+	 */
+	protected abstract Phase checkedNext(long dl);
+
+	@Override
+	public String toString() {
+		return getClass().getSimpleName() + "[" + partyStates + "," + deadline
+				+ "," + evaluator + "]";
+	}
+
+	@Override
+	public int hashCode() {
+		final int prime = 31;
+		int result = 1;
+		result = prime * result
+				+ ((deadline == null) ? 0 : deadline.hashCode());
+		result = prime * result
+				+ ((evaluator == null) ? 0 : evaluator.hashCode());
+		result = prime * result
+				+ ((partyStates == null) ? 0 : partyStates.hashCode());
+		return result;
+	}
+
+	@Override
+	public boolean equals(Object obj) {
+		if (this == obj)
+			return true;
+		if (obj == null)
+			return false;
+		if (getClass() != obj.getClass())
+			return false;
+		DefaultPhase other = (DefaultPhase) obj;
+		if (deadline == null) {
+			if (other.deadline != null)
+				return false;
+		} else if (!deadline.equals(other.deadline))
+			return false;
+		if (evaluator == null) {
+			if (other.evaluator != null)
+				return false;
+		} else if (!evaluator.equals(other.evaluator))
+			return false;
+		if (partyStates == null) {
+			if (other.partyStates != null)
+				return false;
+		} else if (!partyStates.equals(other.partyStates))
+			return false;
+		return true;
+	}
+}
Index: protocol/src/main/java/geniusweb/protocol/session/mopac2/phase/OfferPhase.java
===================================================================
--- protocol/src/main/java/geniusweb/protocol/session/mopac2/phase/OfferPhase.java	(revision 30)
+++ protocol/src/main/java/geniusweb/protocol/session/mopac2/phase/OfferPhase.java	(revision 30)
@@ -0,0 +1,71 @@
+package geniusweb.protocol.session.mopac2.phase;
+
+import java.util.Arrays;
+import java.util.List;
+import java.util.stream.Collectors;
+
+import com.fasterxml.jackson.annotation.JsonCreator;
+import com.fasterxml.jackson.annotation.JsonProperty;
+
+import geniusweb.actions.Action;
+import geniusweb.actions.EndNegotiation;
+import geniusweb.actions.Offer;
+import geniusweb.actions.PartyId;
+import geniusweb.inform.Inform;
+import geniusweb.inform.YourTurn;
+import geniusweb.protocol.ProtocolException;
+import geniusweb.protocol.session.mopac2.PartyStates;
+import geniusweb.voting.VotingEvaluatorWithValue;
+
+public class OfferPhase extends DefaultPhase {
+
+	@JsonCreator
+	public OfferPhase(@JsonProperty("partyStates") PartyStates partyStates,
+			@JsonProperty("deadlinems") Long deadlinems,
+			@JsonProperty("evaluator") VotingEvaluatorWithValue evaluator) {
+		super(partyStates, deadlinems, evaluator);
+	}
+
+	@Override
+	public OfferPhase with(PartyId actor, Action action, long timems) {
+		try {
+			checkAction(actor, action, timems);
+		} catch (ProtocolException ex) {
+			return this.with(ex);
+		}
+		return new OfferPhase(partyStates.with(action), deadline, evaluator);
+	}
+
+	@Override
+	public Inform getInform() {
+		return new YourTurn();
+	}
+
+	@Override
+	public OfferPhase with(ProtocolException e) {
+		System.out.println("Party kicked because of protocol exception:" + e);
+		return new OfferPhase(partyStates.with(e), deadline, evaluator);
+	}
+
+	@Override
+	public Phase finish() {
+		return new OfferPhase(partyStates.finish(), deadline, evaluator);
+	}
+
+	@Override
+	public VotingPhase checkedNext(long deadln) {
+		return new VotingPhase(getOffers(), partyStates.flush(), deadln,
+				evaluator);
+	}
+
+	protected List<Offer> getOffers() {
+		return partyStates.getActions(Offer.class).stream()
+				.collect(Collectors.toList());
+	}
+
+	@Override
+	public List<Class<? extends Action>> getAllowedActions() {
+		return Arrays.asList(Offer.class, EndNegotiation.class);
+	}
+
+}
